/* BlinkenLib
   Copyright 2004-2014 Stefan Schuermans <stefan@schuermans.info>
   Copyleft GNU public license - http://www.gnu.org/copyleft/gpl.html
   a blinkenarea.org project */

#ifndef INC_BlinkenLib_BlinkenProto
#define INC_BlinkenLib_BlinkenProto

#ifdef __cplusplus
extern "C" {
#endif

typedef enum eBlinkenProto { BlinkenProtoNone, BlinkenProtoBlp,
  BlinkenProtoEblp, BlinkenProtoMcuf
} etBlinkenProto;

typedef enum eBlinkenPacket { BlinkenPacketNone, BlinkenPacketFrame,
  BlinkenPacketRequest, BlinkenPacketEndRequest, BlinkenPacketStreamEnd
} etBlinkenPacket;

int BlinkenProtoMakePacket(etBlinkenProto proto, etBlinkenPacket packet,
                           char *pData, int maxLength);
// returns length or -1 on error

void BlinkenProtoDetectPacket(const char *pData, int length,
                              etBlinkenProto * pProto,
                              etBlinkenPacket * pPacket);
// returns protocol in *pProto if pProto not NULL
// returns packet type in *pPacket if pPacket not NULL

#ifdef __cplusplus
} // extern "C"
#endif

#endif // #ifndef INC_BlinkenLib_BlinkenProto
